// WINFLASHDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "WINFLASH.h"
#include "WINFLASHDlg.h"

//#include "tvicport.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static UINT WorkerThread(LPVOID pParam);

typedef struct THREADSTRUCT
{
	CWINFLASHDlg* _this;
} THREADSTRUCT;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWINFLASHDlg Dialogfeld

CWINFLASHDlg::CWINFLASHDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWINFLASHDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWINFLASHDlg)
	m_filename = _T("");
	m_printerports = -1;
	m_bytesleft = 0;
	m_loadaddress_string = _T("");
	m_startaddress_string = _T("");
	m_filelength_string = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Indicate that drag and drop is OK.
	// DragAcceptFiles(TRUE); 
}


void CWINFLASHDlg::DoDataExchange(CDataExchange* pDX)
{
	//m_loadaddress  = 0x800000;
	//m_startaddress = 0x802000;
	//m_filelength   = 0x3fe000;

	// ** TVicPort ** m_printerports = GetLPTNumber()-1; // starts at 0!
	m_printerports = 0; // starts at 0!

	//m_filename = "Testfile";

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWINFLASHDlg)
	DDX_Control(pDX, IDC_LOADADDRESS, m_loadaddress);
	DDX_Control(pDX, IDC_STARTADDRESS, m_startaddress);
	DDX_Text(pDX, IDC_FILENAME, m_filename);
	DDX_Radio(pDX, IDC_LPT1, m_printerports);
	DDX_Text(pDX, IDC_BYTESLEFT, m_bytesleft);
	DDX_Text(pDX, IDC_LOADADDRESS, m_loadaddress_string);
	DDX_Text(pDX, IDC_STARTADDRESS, m_startaddress_string);
	DDX_Text(pDX, IDC_FILELENGTH, m_filelength_string);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWINFLASHDlg, CDialog)
	//{{AFX_MSG_MAP(CWINFLASHDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SENDRESET, OnSendreset)
	ON_BN_CLICKED(IDC_LPT1, OnLpt1)
	ON_BN_CLICKED(IDC_LPT2, OnLpt2)
	ON_BN_CLICKED(IDC_LPT3, OnLpt3)
	ON_BN_CLICKED(IDC_FILESELECT, OnFileselect)
	ON_BN_CLICKED(IDC_TRANSMIT, OnTransmit)
	ON_BN_CLICKED(IDC_CANCELTRANSMISSION, OnCanceltransmission)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWINFLASHDlg Nachrichten-Handler

BOOL CWINFLASHDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	CWnd* pWnd;

	pWnd = (CWnd*)GetDlgItem(IDC_LPT1);
	// ** TVicPort ** pWnd->EnableWindow(GetLPTNumPorts()>=1?1:0);
	pWnd->EnableWindow(1>=1?1:0);
	pWnd = (CWnd*)GetDlgItem(IDC_LPT2);
	// ** TVicPort ** pWnd->EnableWindow(GetLPTNumPorts()>=2?1:0);
	pWnd->EnableWindow(1>=2?1:0);
	pWnd = (CWnd*)GetDlgItem(IDC_LPT3);
	// ** TVicPort ** pWnd->EnableWindow(GetLPTNumPorts()>=3?1:0);
	pWnd->EnableWindow(1>=3?1:0);

	SendDlgItemMessage(IDC_TRANSMISSIONPROGRESS, PBM_SETRANGE, 0, MAKELONG(0, 128)); // 4MB = 128*32KB
	SendDlgItemMessage(IDC_TRANSMISSIONPROGRESS, PBM_SETPOS, 0, 0);         	

	pWnd = (CWnd*)GetDlgItem(IDC_CANCELTRANSMISSION);
	pWnd->EnableWindow(false);
	bCancel=false;

	// ** TVicPort ** nPrinterPortBase = GetLPTBasePort();
	nPrinterPortBase = 0x378;

/* For MaskedEdit-Control CmEdit

	// phone number
	m_edit1.SetMask("\\[[0-9][0-9][0-9]][0-9][0-9][0-9]-[0-9][0-9][0-9][0-9]");
	
	// city
	m_edit2.SetMask("[a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ][a-zA-Z.\\-' ]");
	m_edit2.SetPrompt(' ');

	// state
	m_edit3.SetMask("[acdfghiklmnoprstuvwACDFGHIKLMNOPRSTUVW][acdehijklmnorstvxyzACDEHIJKLMNORSTVXYZ]");
	m_edit3.ConverToUpper(true);

	// zip
	m_edit4.SetMask("[0-9][0-9][0-9][0-9][0-9]-[0-9][0-9][0-9][0-9]");

	m_combo1.AddString("Phone: ([0-9][0-9][0-9]) [0-9][0-9][0-9]-[0-9][0-9][0-9][0-9]");
	m_combo1.AddString("State: [acdfghiklmnoprstuvwACDFGHIKLMNOPRSTUVW][acdehijklmnorstvxyzACDEHIJKLMNORSTVXYZ] Zip: [0-9][0-9][0-9][0-9][0-9]-[0-9][0-9][0-9][0-9]");
	m_combo1.AddString("Mr/Mrs/Ms: [M][rs][s]");
*/
	m_loadaddress.SetMask("$[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]");
	m_loadaddress.ConverToUpper(true);
	m_loadaddress.SetPrompt(' ');

	m_startaddress.SetMask("$[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]");
	m_startaddress.ConverToUpper(true);
	m_startaddress.SetPrompt(' ');

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CWINFLASHDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CWINFLASHDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CWINFLASHDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWINFLASHDlg::OnSendreset() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen

	// ** TVicPort **SetPin(16, 0);		// Setting the INIT\-Signal to Low:
						// Atari FLASH-card enters Reset-loop
	Out32(nPrinterPortBase+kControlReg, (Inp32(nPrinterPortBase+kControlReg) & 0xfb)  | 0x00);  // Set INIT\,  INIT\ is reversed!

	

	for(int i=1; i<10000; i++);	// wait some time
	
	// ** TVicPort **SetPin(16, 1);		// Setting INIT\-Signal to High: 
						// Reset-Loop of the Atari FLASH-card
						// is stopped.
	Out32(nPrinterPortBase+kControlReg, (Inp32(nPrinterPortBase+kControlReg) & 0xfb)  | 0x04);  // Set INIT\,  INIT\ is reversed!
}

void CWINFLASHDlg::OnLpt1() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	// ** TVicPort **SetLPTNumber(1);
	// ** TVicPort **nPrinterPortBase = GetLPTBasePort();
	nPrinterPortBase = 0x378;
}

void CWINFLASHDlg::OnLpt2() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	// ** TVicPort **SetLPTNumber(2);
	// ** TVicPort **nPrinterPortBase = GetLPTBasePort();
	nPrinterPortBase = 0x378;
}

void CWINFLASHDlg::OnLpt3() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	// ** TVicPort **SetLPTNumber(3);
	// ** TVicPort **nPrinterPortBase = GetLPTBasePort();
	nPrinterPortBase = 0x378;
}

void CWINFLASHDlg::OnFileselect() 
{
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
   
	FILE	*stream;

	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	GetPrivateProfileString ("WinFLASH", "Filename", 
                           "", path_buffer, _MAX_PATH,"AtariJaguar.ini"); 

	_splitpath( path_buffer, drive, dir, fname, ext );
	if (lstrlen(ext))
	{
		lstrcpy(ext, ext+1);
		strupr(ext);
	}
	else
		lstrcpy(ext,"ROM");


	char szFilter[] = "ROM Image Dump Files (*.ROM)|*.ROM|ABS Files (*.ABS)|*.ABS|BIN Files (*.BIN)|*.BIN|All Files (*.*)|*.*||";



	CFileDialog fd(true, ext, path_buffer, OFN_HIDEREADONLY|OFN_FILEMUSTEXIST, szFilter);

	if (fd.DoModal() == IDOK)
	{
		m_filename = fd.GetPathName();
		GetDlgItem(IDC_FILENAME)->SetWindowText(m_filename);
		//GetDlgItem(IDC_FILENAME)->SetWindowText(fd.GetPathName());
		//MessageBox(m_filename);
		WritePrivateProfileString("WinFLASH","Filename",m_filename,"AtariJaguar.ini");

		lFileLength = 0;
		lLoadAddress = 0;
		lStartAddress = 0;
		if ( (stream = fopen( m_filename, "rb" )) != NULL )
   		{
			if (!fseek( stream, 0, SEEK_END))
				lFileLength = ftell(stream);	
			// rewind(stream);	// go back to beginning of file!

			// determine the load-address:
			if (lFileLength == 0x100000 || lFileLength == 0x200000 || lFileLength == 0x400000)
				lLoadAddress = 0x800000;	// Dump including 8kb-header
			else
				lLoadAddress = 0x802000; // Without header

			lStartAddress = 0x802000; // Standard start address
			
			fclose(stream);
		}
		m_loadaddress_string.Format("$%lX",lLoadAddress);
		//GetDlgItem(IDC_LOADADDRESS)->SetWindowText(m_loadaddress_string);
		m_loadaddress.SetData(m_loadaddress_string);

		m_startaddress_string.Format("$%lX",lStartAddress);
		//GetDlgItem(IDC_STARTADDRESS)->SetWindowText(m_startaddress_string);
		m_startaddress.SetData(m_startaddress_string);

		m_filelength_string.Format("$%lX",lFileLength);
		GetDlgItem(IDC_FILELENGTH)->SetWindowText(m_filelength_string);

		SendDlgItemMessage(IDC_TRANSMISSIONPROGRESS, PBM_SETPOS, 0, 0); // = 0% because Range is 0..128
		m_bytesleft = lFileLength;
		SetDlgItemInt(IDC_BYTESLEFT, m_bytesleft);
		//GetDlgItem(IDC_BYTESLEFT)->InvalidateRgn(NULL);
		//GetDlgItem(IDC_BYTESLEFT)->UpdateWindow();
	}
	else
	{
		int i,j;
		char szOut[256*10];
		CString char_ascii;
		char szPart[80];
		for (i=0; i<16; i++)
		{
			for (j=0; j<16; j++)
			{ 
			char_ascii.Format("%c",i*16+j);
			char_ascii.AnsiToOem();
			if (j<15)
				sprintf(szPart, " $%2.2X, ",(unsigned char)char_ascii[0]);
			else
				sprintf(szPart, " $%2.2X  ; $%2.2X \n", (unsigned char)char_ascii[0], (unsigned char) i*16);
			strcat(szOut, szPart);
			}
			sprintf(szPart, "AnsiToOem_%2.2X", i);
			WritePrivateProfileString("WinFLASH", szPart, szOut,"AtariJaguar.ini");
			szOut[0] = 0;
		}
		//MessageBox(szOut);
	}
}


void CWINFLASHDlg::OnTransmit() 
{
	m_loadaddress.CopyNonMasked(true);
	m_loadaddress.GetWindowText(m_loadaddress_string);
	sscanf(m_loadaddress_string,"$%LX", &lLoadAddress);

	m_startaddress.CopyNonMasked(true);
	m_startaddress.GetWindowText(m_startaddress_string);
	sscanf(m_startaddress_string,"$%LX", &lStartAddress);

	// Here is where we start the new worker thread
	// this is passed using the void pointer pParam
	// from here on the new thread will do the work
	// and the dialog will be free to move about.

	THREADSTRUCT *_param = new THREADSTRUCT;
	_param->_this = this;
	CWinThread* pWThread = AfxBeginThread(WorkerThread, _param);

}


/*****************************************************
from http://www.paranoia.com/~filipg/HTML/LINK/PORTS/F_PARALLEL5.html#PARALLEL_008

STATUS
	7 6 5 4 3 2 1 0
	* . . . . . . .  Busy . . (pin 11), high=0, low=1 (inverted)
	. * . . . . . .  Ack  . . (pin 10), high=1, low=0 (true)
	. . * . . . . .  No paper (pin 12), high=1, low=0 (true)
	. . . * . . . .  Selected (pin 13), high=1, low=0 (true)
	. . . . * . . .  Error. . (pin 15), high=1, low=0 (true)
	. . . . . * * *  Undefined

CONTROL
	7 6 5 4 3 2 1 0
	* * . . . . . .  Unused (undefined on read, ignored on write)
	. . * . . . . .  Bidirectional control, see below
	. . . * . . . .  Interrupt control, 1=enable, 0=disable
	. . . . * . . .  Select . . (pin 17), 1=low, 0=high (inverted)
	. . . . . * . .  Initialize (pin 16), 1=high, 0=low (true)
	. . . . . . * .  Auto Feed  (pin 14), 1=low, 0=high (inverted)
	. . . . . . . *  Strobe . . (pin 1),  1=low, 0=high (inverted)

Eingabe von Schalterwerten ber den Druckerport:
Im Prinzip kann z.B. der Wert des Statusregisters mit wert := port[adr+1]; oder des Control-Registers mit wert := port[adr+2]; eingelesen werden, aber es sind nicht pro Register 8 Leitungen beschaltet. So setzen verschiedene Interfaces nach eigenen Verfahren Eingabewerte aus den vorhandenen Eingangsbelegungen von Status- und Control-Register zusammen - kann also hier nicht allgemeingltig angegeben werden. Aber Du kannst auch direkt Schalter an die Schnittstelle anschlieen, wenn Du ein paar Vorsichtsmanahmen beachtest.
PIN-Belegung der 25-poligen PC-Parallelportbuchse:

    * 1 - STR (PortC, Bit0)
    * 2 - 9: Daten (Port A, Bit0-7)
    * 10 - ACK (PortB, Bit6)
    * 11 - BSY (PortB, Bit7)
    * 12 - PAP (PortB, Bit5)
    * 13 - OFON (PortB, Bit4)
    * 14 - ALF (PortC, Bit1)
    * 15 - FEH (PortB, Bit3)
    * 16 - INI (PortC, Bit2)
    * 17 - DSL (PortC, Bit3)
    * 18 - 25: Masse-PIN's 

Pin Name    Dir Description
1   /STROBE --> Strobe       (Port C, Bit0)
2   D0      --> Data Bit 0   (Port A, Bit0)
3   D1      --> Data Bit 1   (Port A, Bit1)
4   D2      --> Data Bit 2   (Port A, Bit2)
5   D3      --> Data Bit 3   (Port A, Bit3)
6   D4      --> Data Bit 4   (Port A, Bit4)
7   D5      --> Data Bit 5   (Port A, Bit5)
8   D6      --> Data Bit 6   (Port A, Bit6)
9   D7      --> Data Bit 7   (Port A, Bit7)
10  /ACK    <-- Acknowledge  (Port B, Bit6)
11  BUSY    <-- Busy         (Port B, Bit7)
12  PE      <-- Paper End    (Port B, Bit5)
13  SEL     <-- Select       (Port B, Bit4)
14  /AUTOFD --> Autofeed     (Port C, Bit1)
15  /ERROR  <-- Error        (Port B, Bit3)
16  /INIT   --> Initialize   (Port C, Bit2)
17  /SELIN  --> Select In    (Port C, Bit3)
18  GND     --- Signal Ground
19  GND     --- Signal Ground
20  GND     --- Signal Ground
21  GND     --- Signal Ground
22  GND     --- Signal Ground
23  GND     --- Signal Ground
24  GND     --- Signal Ground
25  GND     --- Signal Ground
******************************************************/

void CWINFLASHDlg::SendByte(unsigned char databyte)
{
//	while (GetLPTBusy())
//		;

	/*
	SetPin(9, (databyte & 0x80) >> 7);		// D7
	SetPin(8, (databyte & 0x40) >> 6);		// D6
	SetPin(7, (databyte & 0x20) >> 5);		// D5
	SetPin(6, (databyte & 0x10) >> 4);		// D4
	SetPin(5, (databyte & 0x08) >> 3);		// D3
	SetPin(4, (databyte & 0x04) >> 2);		// D2
	SetPin(3, (databyte & 0x02) >> 1);		// D1
	SetPin(2, (databyte & 0x01));		// D0
	*/
	// ** TVicPort**TWritePort(nPrinterPortBase, databyte);
	Out32(nPrinterPortBase+kDataReg, databyte);


	//SetPin(1,0);	// Activate Strobe/
	//SetPin(1,1);	// De-Activate Strobe/
	// ** TVicPort **LPTStrobe();

	Out32(nPrinterPortBase+kControlReg, (Inp32(nPrinterPortBase+kControlReg) & 0xfe)  | 0x01);  // Set Strobe,  Strobe is reversed!
    //Wait();
    while( (Inp32(nPrinterPortBase+kStatusReg ) & 0x80) ); // While (not BUSY)
    //Wait();
	Out32(nPrinterPortBase+kControlReg, (Inp32(nPrinterPortBase+kControlReg) & 0xfe)  | 0x00);  // Stop Strobe,  Strobe is reversed!
    //Wait();



//	while (GetLPTBusy())
//		;

}


//**************************************************
/*
	The global thread controller function.
	To begin the new worker thread, use

	CWinThread* pWkrThread = AfxBeginThread(WorkerThread, this);
	see the OnBtnStart() function above

*/
UINT WorkerThread(LPVOID pParam)
{
	long	i;
	FILE	*stream;
	unsigned char buffer[2048];

	
	// Cast void pointer pParam to a CTestThreadDlg pointer passed
	// by the calling function
	THREADSTRUCT* ts = (THREADSTRUCT*)pParam;

	CWINFLASHDlg* pDlg = (CWINFLASHDlg*)ts->_this;

	pDlg->DisableDlgControls();

	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen

	pDlg->MessageBox("Depress and hold down the #3 key on Joypad 1 of your Jaguar,\n and then close this MessageBox by hitting the \"OK\"-button.\n\n Keep the Joypad key #3 depressed till the dark yellow screen appears!", "Initializing the FLASH-upload");

	pDlg->GetDlgItem(IDC_CANCELTRANSMISSION)->SetFocus();


	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

	// Tell the printer-port the new state
	// ** TVicPort ** SetPin(14, false);	// DO: 20040515: Setting the AUTOLF-Signal to LOW: let the LEDs work!!!!
	Out32(pDlg->nPrinterPortBase+kControlReg, (Inp32(pDlg->nPrinterPortBase+kControlReg) & 0xfd)  | 0x02);  // Set AUTOLF\,  AUTOLF\ is reversed!

	// ** TVicPort ** SetPin(17, true);	// DO: 20040515: Setting the SELIN\-Signal to High: let the LEDs work!!!!
	Out32(pDlg->nPrinterPortBase+kControlReg, (Inp32(pDlg->nPrinterPortBase+kControlReg) & 0xf7)  | 0x08);  // Set SELIN\,  SELIN\ is reversed!

	for (i=0; i<1000; i++); // Wait some short time

	// Tell the printer-port the new state
	// ** TVicPort ** SetPin(16, false);	// Setting the INIT\-Signal to Low:
						// Atari FLASH-card enters Reset-loop
	Out32(pDlg->nPrinterPortBase+kControlReg, (Inp32(pDlg->nPrinterPortBase+kControlReg) & 0xfb)  | 0x00);  // Set INIT\,  INIT\ is reversed!

	for (i=0; i<10000; i++); // Wait some short time

	// Tell the printer-port the new state
	// ** TVicPort ** SetPin(16, true);	// Setting the INIT\-Signal to High:
						// Atari FLASH-card leaves Reset-loop and checks for key #3 depressed
	Out32(pDlg->nPrinterPortBase+kControlReg, (Inp32(pDlg->nPrinterPortBase+kControlReg) & 0xfb)  | 0x04);  // Set INIT\,  INIT\ is reversed!


	

	if ( (stream = fopen( pDlg->m_filename, "rb" )) != NULL )
   		{
		// Send LoadAddress
		pDlg->SendByte((unsigned char) ((pDlg->lLoadAddress & 0xff000000)>>24));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) ((pDlg->lLoadAddress & 0x00ff0000)>>16));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) ((pDlg->lLoadAddress & 0x0000ff00)>>8));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) (pDlg->lLoadAddress & 0x000000ff));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};


		// Send StartAddress
		pDlg->SendByte((unsigned char) ((pDlg->lStartAddress & 0xff000000)>>24));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) ((pDlg->lStartAddress & 0x00ff0000)>>16));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) ((pDlg->lStartAddress & 0x0000ff00)>>8));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) (pDlg->lStartAddress & 0x000000ff));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};

		// FileLength = 4; // testetstetstst
		
		// Send FileLength
		pDlg->SendByte((unsigned char) ((pDlg->lFileLength & 0xff000000)>>24));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) ((pDlg->lFileLength & 0x00ff0000)>>16));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) ((pDlg->lFileLength & 0x0000ff00)>>8));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) (pDlg->lFileLength & 0x000000ff));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};

		// Read loop:
		pDlg->lFileChecksum = 0;
		for (i=0; i < pDlg->lFileLength; i++)
			{
			if (i%0x8000 == 0)	// 32KB
			{
				pDlg->m_bytesleft = pDlg->lFileLength-i;
				pDlg->SetDlgItemInt(IDC_BYTESLEFT, pDlg->m_bytesleft);
				pDlg->GetDlgItem(IDC_BYTESLEFT)->InvalidateRgn(NULL);
				pDlg->GetDlgItem(IDC_BYTESLEFT)->UpdateWindow();
				pDlg->SendDlgItemMessage(IDC_TRANSMISSIONPROGRESS, PBM_SETPOS, ((i+1)*128)/pDlg->lFileLength, 0); // Range is 0..128
			}
			fread(buffer, 1, 1, stream);	// Read two bytes into buffer
			pDlg->lFileChecksum += (long)buffer[0];
			pDlg->SendByte (buffer[0]);
			//while (GetLPTBusy())
		    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
			{
				if (pDlg->bCancel)
				{
					pDlg->EnableDlgControls();
					AfxEndThread(1,true);
				}
			};
			if (pDlg->bCancel)	// Need this additonal check if GetLPTBusys()-loop isn't entered (My XP-computer)!
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
			}
		pDlg->m_bytesleft = 0;
		pDlg->SetDlgItemInt(IDC_BYTESLEFT, pDlg->m_bytesleft);
		pDlg->SendDlgItemMessage(IDC_TRANSMISSIONPROGRESS, PBM_SETPOS, 128, 0); // = 100% because Range is 0..128


		// Send FileChecksum
		pDlg->SendByte((unsigned char) ((pDlg->lFileChecksum & 0xff000000)>>24));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) ((pDlg->lFileChecksum & 0x00ff0000)>>16));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) ((pDlg->lFileChecksum & 0x0000ff00)>>8));
		//while (GetLPTBusy())
	    while( !(Inp32(pDlg->nPrinterPortBase+kStatusReg ) & 0x80) ); // While (BUSY)
		{
			if (pDlg->bCancel)
			{
				pDlg->EnableDlgControls();
				AfxEndThread(1,true);
			}
		};
		pDlg->SendByte((unsigned char) (pDlg->lFileChecksum & 0x000000ff));
		// while (GetLPTBusy());	!!!! Don't wait for Busy after the last Byte being sent!

		fclose(stream);
		}



	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));

	pDlg->EnableDlgControls();

	return 0;
}

void CWINFLASHDlg::DisableDlgControls()
{
	CWnd* pWnd;

	pWnd = (CWnd*)GetDlgItem(IDC_LPT1);
	pWnd->EnableWindow(FALSE);
	pWnd = (CWnd*)GetDlgItem(IDC_LPT2);
	pWnd->EnableWindow(FALSE);
	pWnd = (CWnd*)GetDlgItem(IDC_LPT3);
	pWnd->EnableWindow(FALSE);

	pWnd = (CWnd*)GetDlgItem(IDC_FILESELECT);
	pWnd->EnableWindow(FALSE);

	pWnd = (CWnd*)GetDlgItem(IDC_LOADADDRESS);
	pWnd->EnableWindow(FALSE);

	pWnd = (CWnd*)GetDlgItem(IDC_STARTADDRESS);
	pWnd->EnableWindow(FALSE);

	pWnd = (CWnd*)GetDlgItem(IDC_TRANSMIT);
	pWnd->EnableWindow(FALSE);

	pWnd = (CWnd*)GetDlgItem(IDC_SENDRESET);
	pWnd->EnableWindow(FALSE);

	pWnd = (CWnd*)GetDlgItem(IDC_CANCELTRANSMISSION);
	pWnd->EnableWindow(true);
	pWnd->SetFocus();
	bCancel=false;
}

void CWINFLASHDlg::EnableDlgControls()
{
	CWnd* pWnd;

	pWnd = (CWnd*)GetDlgItem(IDC_LPT1);
	// ** TVicPort ** pWnd->EnableWindow(GetLPTNumPorts()>=1?1:0);
	pWnd->EnableWindow(1>=1?1:0);
	pWnd = (CWnd*)GetDlgItem(IDC_LPT2);
	// ** TVicPort ** pWnd->EnableWindow(GetLPTNumPorts()>=2?1:0);
	pWnd->EnableWindow(1>=2?1:0);
	pWnd = (CWnd*)GetDlgItem(IDC_LPT3);
	// ** TVicPort ** pWnd->EnableWindow(GetLPTNumPorts()>=3?1:0);
	pWnd->EnableWindow(1>=3?1:0);

	pWnd = (CWnd*)GetDlgItem(IDC_FILESELECT);
	pWnd->EnableWindow(TRUE);

	pWnd = (CWnd*)GetDlgItem(IDC_LOADADDRESS);
	pWnd->EnableWindow(TRUE);

	pWnd = (CWnd*)GetDlgItem(IDC_STARTADDRESS);
	pWnd->EnableWindow(TRUE);

	pWnd = (CWnd*)GetDlgItem(IDC_TRANSMIT);
	pWnd->EnableWindow(TRUE);
	pWnd->SetFocus();

	pWnd = (CWnd*)GetDlgItem(IDC_SENDRESET);
	pWnd->EnableWindow(TRUE);

	pWnd = (CWnd*)GetDlgItem(IDC_CANCELTRANSMISSION);
	pWnd->EnableWindow(false);
	bCancel=false;

}

void CWINFLASHDlg::OnCanceltransmission() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	bCancel = true;	// This will cancel the Workerthread!
	
}


